
/*  @(#)user.c 1.4 95/02/06
 *
 *  Various routines associated with the user name popup.
 *
 *  Copyright (c) Rich Burridge.    All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors or inaccuracies inherent
 *  either to the comments or the code of this program, but if
 *  reported to me then an attempt will be made to fix them.
 */

#include "mptool.h"

Widget upopup ;            /* User Name options popup. */
Widget *uwarr ;


void
do_un_apply(void)
{
  char m[MAXLINE] ;
 
  set_str_opt_val(O_ALIAS, get_str_value(F_USER, WI_ALIASNAME)) ;
 
  set_int_opt_val(O_NAMELEN, get_int_value(F_USER, WI_UN_CHARS)) ;
  if (int_opt_val(O_NAMELEN) < 1 || int_opt_val(O_NAMELEN) > MAXLINELENGTH)
    {
      SPRINTF(m, mptool_strs[(int) S_INVCHARS], NAMELENGTH) ;
      notice(uwarr[WI_USERNAME_FRAME], m) ;
      set_int_opt_val(O_NAMELEN, NAMELENGTH) ;
      set_int_value(F_USER, WI_UN_CHARS, int_opt_val(O_NAMELEN)) ;
    } 
    
  set_int_opt_val(O_NAMEF, get_int_value(F_USER, WI_UN_WORDS)) ;
  if (int_opt_val(O_NAMEF) < 1 || int_opt_val(O_NAMEF) > MAXLINELENGTH)
    {
      SPRINTF(m, mptool_strs[(int) S_INVWORDS], NAMEFIELDS) ;
      notice(uwarr[WI_USERNAME_FRAME], m) ;
      set_int_opt_val(O_NAMEF, NAMEFIELDS) ;
      set_int_value(F_USER, WI_UN_WORDS, int_opt_val(O_NAMEF)) ;
    } 
}
 
 
void
do_un_dismiss(void)
{
  XtUnmapWidget(upopup) ;
  XtUnmanageChild(upopup) ;
}
 
 
void
do_un_reset(void)
{
  set_str_value(F_USER, WI_ALIASNAME, str_opt_val(O_ALIAS)) ;
  set_int_value(F_USER, WI_UN_CHARS,  int_opt_val(O_NAMELEN)) ;
  set_int_value(F_USER, WI_UN_WORDS,  int_opt_val(O_NAMEF)) ;
}


void
do_show_username(void)
{
  if (!upopup)
    {
      upopup = tu_username_frame_widget("username", warr[WI_MAIN_FRAME],
                                         &uwarr) ;
      add_delete_callback(upopup) ;
      add_help(uwarr[WI_UN_FORM],         wi_un_form_help) ;
      add_help(uwarr[WI_UN_APPLY],        wi_un_apply_help) ;
      add_help(uwarr[WI_UN_RESET],        wi_un_reset_help) ;
      add_help(uwarr[WI_UN_DISMISS],      wi_un_dismiss_help) ;
      add_help(uwarr[WI_ALIASNAME_LABEL], wi_aliasname_help) ;
      add_help(uwarr[WI_ALIASNAME],       wi_aliasname_help) ;
      add_help(uwarr[WI_UNC_LABEL],       wi_props_passc_help) ;
      add_help(uwarr[WI_UN_CHARS],        wi_props_passc_help) ;
      add_help(uwarr[WI_UNW_LABEL],       wi_props_passw_help) ;
      add_help(uwarr[WI_UN_WORDS],        wi_props_passw_help) ;
      do_un_reset() ;
    } 
  show_popup(upopup) ;
}


void
User(void)
{  
  uwarr = NULL ;           /* No widgets defined initially. */
  upopup = NULL ;          /* No user name popup window initially. */
}
